#!/bin/bash
# cancella tutti vecchi file di log (quelli compressi e di backup), non i nuovi
# va eseguito da root
# scritto da Giovanni Ubaldi www.ubaweb.it il 19 agosto 2012
# pubblicato il 19 agosto 2012 su http://www.ubaweb.it/miniguide/
clear
DIR_LOG='/var/log/'	# directory contenente i file di log
ROOT_UID=0     		# $UID 0 = root

if [ "$UID" -ne "$ROOT_UID" ]
then
  echo "È necessario eseguire lo script da root."
  exit 1
fi 

cd /var/log || {
echo "Non riesco a spostarmi nella directory stabilita." >&2
exit $E_XCD;
}

# METODO MENO PRECISO MA SENZA BC
#prima_M=$(du -s --block-size=M)
#prima=$(echo $prima_M | grep -o '[0-9]*') # PULIZIA, prendo solo i numeri (mega senza M)
#prima_kb=$(( prima * 1024 ))

prima_b=$(du -sb)	#calcolo (-s:totale) dello spazio occupato (-b:in bytes)
prima_b=$(echo $prima_b | grep -o '[0-9]*')		# PULIZIA, prendo solo i numeri
prima_kb=$(echo "$prima_b / 1024" | bc -l)		# calcolo kb con decimali
prima_kb_arr=$(echo $prima_kb | awk '{printf("%.2f\n", $1)}')	#arrotondo a 2 cifre
prima_mb=$(echo "$prima_kb / 1024" | bc -l)		#calcolo mb con decimali
prima_mb_arr=$(echo $prima_mb | awk '{printf("%.2f\n", $1)}')	#arrotondo a 2 cifre
echo -e "Lo spazio totale occupato dai log è:
in bytes\t$prima_b
in Kbytes\t$prima_kb_arr
in Mbytes\t$prima_mb_arr"

rm "$DIR_LOG"*.gz 2>/dev/null
echo -e "\nCancello i file .gz in /var/log/"
rm "$DIR_LOG"*.1 2>/dev/null
echo -e "\n\tCancello i file .1 in /var/log/"
rm "$DIR_LOG"*.*old 2>/dev/null
echo -e "\n\t\tCancello i file .old in /var/log/"
rm -r "$DIR_LOG"*/*.gz 2>/dev/null
echo -e "\n\nCancello i file .gz nelle sottodirectory di $DIR_LOG"
rm -r "$DIR_LOG"*/*.1 2>/dev/null
echo -e "\n\tCancello i file .1 nelle sottodirectory di $DIR_LOG"
rm -r "$DIR_LOG"*/*.*old 2>/dev/null
echo -e "\n\t\tCancello i file .old nelle sottodirectory di $DIR_LOG\n"

dopo_b=$(du -sb)	#calcolo (-s:totale) dello spazio occupato (-b:in bytes)
dopo_b=$(echo $dopo_b | grep -o '[0-9]*')		# PULIZIA, prendo solo i numeri
dopo_kb=$(echo "$dopo_b / 1024" | bc -l)		# calcolo kb con decimali
dopo_kb_arr=$(echo $dopo_kb | awk '{printf("%.2f\n", $1)}')	#arrotondo a 2 cifre
dopo_mb=$(echo "$dopo_kb / 1024" | bc -l)		#calcolo mb con decimali
dopo_mb_arr=$(echo $dopo_mb | awk '{printf("%.2f\n", $1)}')	#arrotondo a 2 cifre
echo -e "Lo spazio totale occupato dai log dopo l'eliminazione è:
in bytes\t$dopo_b
in Kbytes\t$dopo_kb_arr
in Mbytes\t$dopo_mb_arr"

dif_b=$(( $prima_b - $dopo_b ))
dif_kb=$(echo "$dif_b / 1024" | bc -l)		# calcolo kb con decimali
dif_kb_arr=$(echo $dif_kb | awk '{printf("%.2f\n", $1)}')	#arrotondo a 2 cifre
dif_mb=$(echo "$dif_kb / 1024" | bc -l)		#calcolo mb con decimali
dif_mb_arr=$(echo $dif_mb | awk '{printf("%.2f\n", $1)}')	#arrotondo a 2 cifre

sleep 4

#clear

echo -e "\n\t\t\t\t  Report\n"
echo -e "Spazio occupato prima dell'eliminazione dei vecchi log (Mbytes): $prima_mb_arr \n"
echo -e "\nSpazio occupato dopo l'eliminazione dei vecchi log (Mbytes):\t $dopo_mb_arr\n"
echo -e "\n\nSpazio recuperato:
in bytes\t$dif_b
in Kbytes\t$dif_kb_arr
in Mbytes\t$dif_mb_arr
\n\n\t\t\t    (-8    FINE    8-)\n"
exit 0
